#undef __NO_VERSION__
#include <linux/version.h>

#include <linux/string.h>
#include <linux/errno.h>
#ifdef MODULE
   #if defined(CONFIG_MODVERSIONS) && !defined(MODVERSIONS)
      #define MODVERSIONS
   #endif

   #ifdef MODVERSIONS
      #include <config/modversions.h>
   #endif

   #include <linux/module.h>
#endif

#include "nikal.h"

#ifdef MODULE_LICENSE
   #ifdef nNIKAL100_kCopyrightString
      MODULE_LICENSE(nNIKAL100_kCopyrightString);
   #endif
#endif

#ifdef MODULE_AUTHOR
   #ifdef nNIKAL100_kAuthorString
      MODULE_AUTHOR(nNIKAL100_kAuthorString);
   #endif
#endif

#ifdef MODULE_DESCRIPTION
   #ifdef nNIKAL100_kDescriptionString
      MODULE_DESCRIPTION(nNIKAL100_kDescriptionString);
   #endif
#endif


#include <linux/mod_devicetable.h>

int nNIAPAL200_driverEntry(struct nNIKAL100_tDriver *driver);

static struct nNIKAL100_tDriver atomicDriver;
static void* nativeDriverRegistration;

/* native driver registration functions. These functions are auto-generated */
void *registerNativeDriver(nNIKAL100_tDriver*);
void unregisterNativeDriver(void*);

int init_module(void)
{
   atomicDriver.module = THIS_MODULE;

   if (nNIAPAL200_driverEntry(&atomicDriver))
      return -ENODEV;

   nativeDriverRegistration = registerNativeDriver(&atomicDriver);

   if (nativeDriverRegistration == NULL)
   {
      if (atomicDriver.unload)
         atomicDriver.unload(&atomicDriver);
      return -ENODEV;
   }

   return 0;
}

void cleanup_module(void)
{
   unregisterNativeDriver(nativeDriverRegistration);

   if (atomicDriver.unload)
      atomicDriver.unload(&atomicDriver);
}

/* native driver registration is no-op */
void *registerNativeDriver(struct nNIKAL100_tDriver* ignore)
{
   static int some_non_null_storage_ignoreme;
   return &some_non_null_storage_ignoreme;
}
void unregisterNativeDriver(void* ignore) { }


#define nNIKAL100_mExportSymbol EXPORT_SYMBOL
extern int nNICHENUM000_getComboCdaqInfo;
nNIKAL100_mExportSymbol(nNICHENUM000_getComboCdaqInfo);
/* _ZN12nNICHENUM00010nNIAPAL00026nNIAPAL200_getKalDriverPtrEv=_079b5bcfddf71a28675be3e1ad78c806 */
extern int _079b5bcfddf71a28675be3e1ad78c806;
nNIKAL100_mExportSymbol(_079b5bcfddf71a28675be3e1ad78c806);
extern int _ZN12nNICHENUM00017getCurrentVersionERi;
nNIKAL100_mExportSymbol(_ZN12nNICHENUM00017getCurrentVersionERi);
extern int _ZN12nNICHENUM00026getOldestCompatibleVersionERi;
nNIKAL100_mExportSymbol(_ZN12nNICHENUM00026getOldestCompatibleVersionERi);
/* _ZN12nNICHENUM00014compareVersionERK10tSSVersionS2_RiPKc=_e80ec62cd00af3b4ccac53b75f0d1dd7 */
extern int _e80ec62cd00af3b4ccac53b75f0d1dd7;
nNIKAL100_mExportSymbol(_e80ec62cd00af3b4ccac53b75f0d1dd7);
